/*******************************************************************************/
/* Car Alarm System                                                            */
/*******************************************************************************/
/* as described in                                                             */
/*     http://www.mogentes.eu/public/deliverables/
                MOGENTES_3-15_1.0r_D3.4b_TestTheories-final_main.pdf           */
/*******************************************************************************/

#define TIMEOUT1 3 // 4 //4 //400
#define TIMEOUT2 3 // 5 //5 //600
#define TIMEOUT3 3 // 10 //10 //5400

#include "Alarm_system.c"
#include "cas_alarm_f.c"

#ifndef NO_CBMC

void input_assume(t_cas_alarm_f_io *_io_) {
  __CPROVER_assume((0<=_io_->In1) && (_io_->In1<=1) && // VehLocked
                   (0<=_io_->In2) && (_io_->In2<=1));  // AlarmSensor
}

extern t_cas_alarm_f_io nondet_io();

#endif


int main() {
  int k=0;
  t_cas_alarm_f_state _state_; 
  cas_alarm_f_init(&_state_);
  while(1) {
    t_cas_alarm_f_io _io_ = nondet_io();

#ifdef NO_CBMC
    printf("s = { Counter=%d\n      Alarm_system=%d\n      InitSystem=%d\n      VehicleOpen=%d\n      AlarmWillBeArmedAfter20sec=%d\n      AlarmWillBeArmedAfter20sec_CounterStart=%d\n      AlarmWillBeArmedAfter20sec_CounterPlus=%d\n      AlarmWillBeArmedAfter20sec_CounterEnd=%d\n      AlarmArmed=%d\n      AlarmAcousticAndOptical=%d\n      AlarmAcousticAndOptical_CounterStart=%d\n      AlarmAcousticAndOptical_CounterPlus=%d\n      AlarmAcousticAndOptical_CounterEnd=%d\n      AlarmOnlyOptical=%d\n      AlarmOnlyOptical_CounterStart=%d\n      AlarmOnlyOptical_CounterPlus=%d\n      AlarmOnlyOptical_CounterEnd=%d }\n",
  _state_.Alarm_system_data.Counter
  ,_state_.Alarm_system_state.Alarm_system_OPEN
  ,_state_.Alarm_system_state.InitSystem_OPEN
  ,_state_.Alarm_system_state.VehicleOpen_OPEN
  ,_state_.Alarm_system_state.AlarmWillBeArmedAfter20sec_OPEN
  ,_state_.Alarm_system_state.AlarmWillBeArmedAfter20sec_CounterStart_OPEN
  ,_state_.Alarm_system_state.AlarmWillBeArmedAfter20sec_CounterPlus_OPEN
  ,_state_.Alarm_system_state.AlarmWillBeArmedAfter20sec_CounterEnd_OPEN
  ,_state_.Alarm_system_state.AlarmArmed_OPEN
  ,_state_.Alarm_system_state.AlarmAcousticAndOptical_OPEN
  ,_state_.Alarm_system_state.AlarmAcousticAndOptical_CounterStart_OPEN
  ,_state_.Alarm_system_state.AlarmAcousticAndOptical_CounterPlus_OPEN
  ,_state_.Alarm_system_state.AlarmAcousticAndOptical_CounterEnd_OPEN
  ,_state_.Alarm_system_state.AlarmOnlyOptical_OPEN
  ,_state_.Alarm_system_state.AlarmOnlyOptical_CounterStart_OPEN
  ,_state_.Alarm_system_state.AlarmOnlyOptical_CounterPlus_OPEN
  ,_state_.Alarm_system_state.AlarmOnlyOptical_CounterEnd_OPEN);
    state_assert(&_state_);
   printf("i = {%d%d}\n",_io_.In1,_io_.In2);
#endif

   t_cas_alarm_f_state old_state_ = _state_;
   cas_alarm_f_compute(&_io_,&_state_);

#ifndef NO_CBMC
   input_assume(&_io_);

   //properties
  if(old_state_.Alarm_system_state.InitSystem_OPEN && 
     !old_state_.Alarm_system_state.VehicleOpen_OPEN &&
     !_io_.In1 && !_io_.In2) 
     __CPROVER_assert(_state_.Alarm_system_state.VehicleOpen_OPEN,
                  "c::prop1");

  if((old_state_.Alarm_system_state.AlarmArmed_OPEN ||
      old_state_.Alarm_system_state.AlarmAcousticAndOptical_OPEN ||
      old_state_.Alarm_system_state.AlarmOnlyOptical_OPEN)
      && old_state_.Alarm_system_data.Counter>1
      && !_io_.In1 && !_io_.In2)
     __CPROVER_assert(_state_.Alarm_system_state.VehicleOpen_OPEN, 
                   "c::prop2");

   if(old_state_.Alarm_system_state.AlarmArmed_OPEN && _io_.In2)
     __CPROVER_assert(_state_.Alarm_system_state.AlarmAcousticAndOptical_OPEN,
                   "c::prop3");

  
    if(old_state_.Alarm_system_state.AlarmAcousticAndOptical_OPEN && 
       old_state_.Alarm_system_state.AlarmAcousticAndOptical_CounterEnd_OPEN && 
      _io_.In1)
      __CPROVER_assert(_state_.Alarm_system_state.AlarmOnlyOptical_OPEN,
		     "c::prop4");

  
    if(old_state_.Alarm_system_state.AlarmOnlyOptical_OPEN && 
      old_state_.Alarm_system_state.AlarmOnlyOptical_CounterEnd_OPEN && 
      _io_.In1)
       __CPROVER_assert(_state_.Alarm_system_state.AlarmArmed_OPEN,
		     "c::prop5");

  
    if(old_state_.Alarm_system_state.AlarmAcousticAndOptical_OPEN && !_io_.In1
       && old_state_.Alarm_system_data.Counter>1)
      __CPROVER_assert(_state_.Alarm_system_state.VehicleOpen_OPEN,
		     "c::prop6");

  
    if(old_state_.Alarm_system_state.AlarmOnlyOptical_OPEN && !_io_.In1
       && old_state_.Alarm_system_data.Counter>1)
      __CPROVER_assert(_state_.Alarm_system_state.VehicleOpen_OPEN,
		     "c::prop7");

  
    if(old_state_.Alarm_system_state.VehicleOpen_OPEN && !_io_.In1 && _io_.In2)
      __CPROVER_assert(_state_.Alarm_system_state.VehicleOpen_OPEN,
		       "c::prop8");

  
    if(old_state_.Alarm_system_state.AlarmWillBeArmedAfter20sec_OPEN && 
       old_state_.Alarm_system_data.Counter>1 && 
      _io_.In1 && _io_.In2)
    __CPROVER_assert(_state_.Alarm_system_state.AlarmWillBeArmedAfter20sec_OPEN,
		     "c::prop9");

  
    if(old_state_.Alarm_system_state.AlarmAcousticAndOptical_OPEN && 
       old_state_.Alarm_system_data.Counter>1 && 
      _io_.In1 && _io_.In2)
     __CPROVER_assert(_state_.Alarm_system_state.AlarmAcousticAndOptical_OPEN,
		      "c::prop10");

  
    if(old_state_.Alarm_system_state.AlarmOnlyOptical_OPEN && 
       old_state_.Alarm_system_data.Counter>1 && 
      _io_.In1 && _io_.In2)
      __CPROVER_assert(_state_.Alarm_system_state.AlarmOnlyOptical_OPEN,
		       "c::prop11");

  
    if(old_state_.Alarm_system_state.AlarmArmed_OPEN && _io_.In1 && !_io_.In2)
      __CPROVER_assert(_state_.Alarm_system_state.AlarmArmed_OPEN,
		     "c::prop12");

  
    if(old_state_.Alarm_system_state.AlarmArmed_OPEN && !_io_.In1 && !_io_.In2)
      __CPROVER_assert(_state_.Alarm_system_state.VehicleOpen_OPEN,
		     "c::prop13");

  
    if(old_state_.Alarm_system_state.AlarmAcousticAndOptical_OPEN && !_io_.In1
        && old_state_.Alarm_system_data.Counter>1)
      __CPROVER_assert(_state_.Alarm_system_state.VehicleOpen_OPEN,
		       "c::prop14");

  
    if(old_state_.Alarm_system_state.AlarmOnlyOptical_OPEN && !_io_.In1
        && old_state_.Alarm_system_data.Counter>1)
      __CPROVER_assert(_state_.Alarm_system_state.VehicleOpen_OPEN,
		       "c::prop15");

  
    if(old_state_.Alarm_system_state.InitSystem_OPEN && !_io_.In1)
    __CPROVER_assert(_state_.Alarm_system_state.VehicleOpen_OPEN,
		     "c::prop16");

  
    if(old_state_.Alarm_system_state.InitSystem_OPEN && _io_.In1)
    __CPROVER_assert(_state_.Alarm_system_state.AlarmWillBeArmedAfter20sec_OPEN,
		     "c::prop17");

    //final states to be reached
    if(_state_.Alarm_system_state.VehicleOpen_OPEN)
      __CPROVER_assert(1,"c::final");

#endif
  }
  return 0;
}

