%option nounput

%{
#include <string>

#include <util/string2int.h>
#include "clingo_parser.h"
#include "clingo_yyparser.h"

#define PARSER clingo_parser

%}

%option noyywrap
%option batch
%option prefix="clingo_yy"
%option outfile="clingo_lexer.cpp" 
%option header-file="clingo_lexer.h" 

%%

[0-9]+ { 
  clingo_yylval.num = safe_string2unsigned(std::string(clingo_yytext, clingo_yyleng)); 
  return NUM_CST; 
}

"cycle"          { return TK_CYCLEPAIR; }
"Answer:"        { return TK_ANSWER; }
"UNSATISFIABLE"  { return TK_UNSAT; }
"OPTIMUM FOUND"  { return TK_OPTFOUND; }

"("      { return TK_LPAREN; }
")"      { return TK_RPAREN; }
","      { return TK_COMMA; }

[ \t\n\r]      { }
"Models"[^\n]*\n    { }
"Time"[^\n]*\n    { }
"Pre"[^\n]*\n    { }
"Solving"[^\n]*\n    { }
"Enumerated"[^\n]*\n    { }
"Opt"[^\n]*\n    { }


%%

