%{
#include <string>
#include <iostream>
#include "clingo_parser.h" 

int clingo_yylex();
extern char *clingo_yytext;

clingo_parsert clingo_parser;

int clingo_yyerror(const std::string &error)
{
  std::cout << "CLINGO PARSE ERROR: " << error << std::endl;
  return 0;
}

/* call this function */
bool clingo_parse(std::istream &_in, cyclet* _cycle) {
  clingo_parser.cycle = _cycle;
  clingo_parser.in = &_in;
  return clingo_parser.parse();
} 

%}

%error-verbose
%defines "clingo_yyparser.h"
%output "clingo_parser.cpp"
%name-prefix="clingo_yy"

%union {
  unsigned num;
}

%token <num> NUM_CST
%token TK_EOF TK_LPAREN TK_RPAREN TK_ANSWER TK_UNSAT TK_COMMA TK_CYCLEPAIR TK_OPTFOUND

%type <cyclet> cycle

%start response


%%

response: 
  TK_UNSAT
{
  clingo_parser.cycle->clear();
}
| result_list TK_OPTFOUND

result_list:
  result
| result_list result

result: 
  TK_ANSWER NUM_CST 
{
  clingo_parser.cycle->clear();
}
  cycle_list

cycle_list:
  cycle
| cycle_list cycle

cycle: TK_CYCLEPAIR TK_LPAREN NUM_CST TK_COMMA NUM_CST TK_RPAREN
{
  clingo_parser.cycle->insert(cycle_pairt($3,$5));
}
