/*******************************************************************\

Module: K-reach property graphs

Author: Peter Schrammel

\*******************************************************************/

#ifndef CHAINCOVER_GRAPH_H
#define CHAINCOVER_GRAPH_H

#include <util/message.h>
#include "graph_weighted.h"
#include "hampath_solver_lkh.h"
#include "hampath_solver_clingo.h"
#include <iostream>

typedef irep_idt propertyt;

#define forall_nodeLabels(node, graph) \
  for(std::map<nodeidt,propertyt>::iterator node=(graph).nodeLabels.begin(); \
      node!=(graph).nodeLabels.end(); ++node)

#define forall_edgeLabels(edge, graph) \
  for(std::map<edgeidt,edgeweightt>::iterator edge=(graph).edgeLabels.begin(); \
      edge!=(graph).edgeLabels.end(); ++edge)

#define forall_edges(edge, graph) \
  for(std::map<edgeidt,edget>::iterator edge=(graph).edges.begin(); \
      edge!=(graph).edges.end(); ++edge)

#define forall_nodesPath(node, path) \
  for(patht::iterator node=(path).begin();	\
      node!=(path).end(); ++node)

typedef hampath_solver_templatet<nodeidt, propertyt, edgeidt> hampath_solvert;

/** k-reach property graph implementation */
class grapht : public graph_weighted_intidst<propertyt> {

 public:
 grapht() : graph_weighted_intidst<propertyt>() {}
 grapht(hampath_solvert* solver) : graph_weighted_intidst<propertyt>(solver) {}
};
#endif
