%option nounput

%{
#include <string>

#include <util/string2int.h>
#include "lkh_parser.h"
#include "lkh_yyparser.h"

#define PARSER lkh_parser

%}

%option noyywrap
%option batch
%option prefix="lkh_yy"
%option outfile="lkh_lexer.cpp" 
%option header-file="lkh_lexer.h" 

%%

[0-9]+ { 
  lkh_yylval.num = safe_string2unsigned(std::string(lkh_yytext, lkh_yyleng)); 
  return NUM_CST; 
}

"COMMENT : Length ="  { return TK_LENGTH; }
"TOUR_SECTION"  { return TK_TOUR_BEGIN; }
"-1"        { return TK_TOUR_END; }

[ \t\n\r]      { }
"NAME"[^\n]*\n    { }
"COMMENT : Found"[^\n]*\n    { }
"TYPE"[^\n]*\n    { }
"DIMENSION"[^\n]*\n    { }
"EOF"[^\n]*\n    { }


%%

