/*******************************************************************\

Module: LKH interface

Author: Peter Schrammel

\*******************************************************************/

#ifndef CHAINCOVER_LKH_PARSER_H
#define CHAINCOVER_LKH_PARSER_H

#include <util/parser.h>
#include "graph_weighted.h"

int lkh_yyparse();

typedef std::list<int> lkh_patht;

class lkh_parsert:public parsert
{
public:
  virtual bool parse()
  {
    return lkh_yyparse();
  } 

  lkh_patht* path;
  unsigned* cost;
  std::istream* _in;
};

extern lkh_parsert lkh_parser;

/* call this function */
bool lkh_parse(std::istream &_in, lkh_patht* _path, unsigned* _cost);

#endif
