%{
#include <string>
#include <iostream>
#include "lkh_parser.h" 

int lkh_yylex();
extern char *lkh_yytext;

lkh_parsert lkh_parser;

int lkh_yyerror(const std::string &error)
{
  std::cout << "LKH PARSE ERROR: " << error << std::endl;
  return 0;
}

/* call this function */
 bool lkh_parse(std::istream &_in, lkh_patht* _path, unsigned* _cost) {
  lkh_parser.path = _path;
  lkh_parser.path->clear();
  lkh_parser.cost = _cost;
  lkh_parser.in = &_in;
  return lkh_parser.parse();
} 

%}

%error-verbose
%defines "lkh_yyparser.h"
%output "lkh_parser.cpp"
%name-prefix="lkh_yy"

%union {
  unsigned num;
}

%token <num> NUM_CST
%token TK_EOF TK_LENGTH TK_TOUR_BEGIN TK_TOUR_END

%type <lkh_patht> tour

%start response


%%

response: 
  TK_LENGTH NUM_CST
  TK_TOUR_BEGIN tour TK_TOUR_END
{
  *lkh_parser.cost = $2;
}


tour:
  NUM_CST
{
  lkh_parser.path->push_back($1);
}
| tour NUM_CST
{
  lkh_parser.path->push_back($2);
}
