/*******************************************************************\

Module: Test chain generation using optimisation and SAT solving

Author: Peter Schrammel

\*******************************************************************/

#ifndef CHAINCOVER_TESTCHAIN_OPT_H
#define CHAINCOVER_TESTCHAIN_OPT_H

#include "../test_base.h"
#include "config_parser_opt_xml.h"

#define CFG_TMPFILE "./__cfg__.xml"


class testchain_optt : public test_baset 
{
 public:
  testchain_optt(const optionst &_options,
                 message_handlert& _message_handler,
                 config_parser_opt_xmlt *_config_parser) :
  test_baset(_options,_message_handler), config(_config_parser)
  {
  }

  virtual void compute(goto_functionst &goto_functions,
                       symbol_tablet &symbol_table); 

 protected:
  config_parser_opt_xmlt *config;

};

#endif
