#ifndef ACCELERATE_ACCELERATE_H
#define ACCELERATE_ACCELERATE_H

#include <util/namespace.h>
#include <iostream>

#include <analyses/natural_loops.h>

#include <goto-programs/goto_functions.h>

#include <goto-instrument/accelerate/path.h>
#include <goto-instrument/accelerate/looppath_select.h>

class acceleratet {
 public:
  acceleratet(goto_programt &_program,
              goto_functionst &_goto_functions,
              const namespacet &_ns,
              looppath_selectt &_looppath_select) :
      program(_program),
      goto_functions(_goto_functions),
      ns(_ns),
      looppath_select(_looppath_select)
  {
    natural_loops(program);
    std::cout << natural_loops.loop_map.size() << " loop(s) found " << std::endl;
  }

  int accelerate_loop(goto_programt::targett loop_header);
  int accelerate_loops();

  bool accelerate(patht &path, goto_programt &accelerator);

 protected:
  void add_accelerator(goto_programt::targett loop_header,
                       goto_programt &accelerator);

  goto_programt &program;
  goto_functionst &goto_functions;
  const namespacet &ns;
  natural_loops_mutablet natural_loops;
  looppath_selectt &looppath_select;

  typedef map<patht, goto_programt> accelerator_mapt;
};

typedef enum{LOOPPATH_SELECT_ALL=0, 
             LOOPPATH_SELECT_BLOCKS=1, 
             LOOPPATH_SELECT_FILTER=2, 
             LOOPPATH_SELECT_FILTER_BLOCKS=3 } looppath_select_typet;

void accelerate_functions(
  goto_functionst &functions,
  const namespacet &ns,
  looppath_select_typet looppath_select_type);

#endif
