#ifndef CPROVER_ACCELERATE_LOOP_PARALLELIZER_H
#define CPROVER_ACCELERATE_LOOP_PARALLELIZER_H

#include <util/namespace.h>
#include <iostream>
#include <goto-programs/goto_functions.h>

#include "util.h"
#include "dependencies.h"

class loop_parallelizert {
 public:
  loop_parallelizert(goto_programt &_program,
              goto_functionst &_goto_functions,
 	      const namespacet &_ns) :
    deps(_program,_goto_functions,_ns),
    ns(_ns)
  {
  }

  void do_it(goto_programt::targett &start, goto_programt::targett &end, 
             unsigned min_size);
  
  goto_programt result;

 protected:
  dependenciest deps;
  const namespacet &ns;

  void transform(goto_programt::targett &start,goto_programt::targett &end);
  exprt make_guard(const dependenciest::branchest &b);
  exprt make_guard(const dependenciest::brancht &b);

};


#endif
