#ifndef ACCELERATE_LOOPPATH_SELECT_H
#define ACCELERATE_LOOPPATH_SELECT_H

#include <util/namespace.h>
#include <iostream>

#include <analyses/natural_loops.h>

#include <goto-programs/goto_functions.h>

#include "path.h"

class looppath_selectt {
 public:
  looppath_selectt(goto_programt &_program,
              goto_functionst &_goto_functions,
 	      const namespacet &_ns) :
      program(_program),
      goto_functions(_goto_functions),
      ns(_ns)
  {
  }

  virtual void find_paths(goto_programt::targett loop_header,
                  natural_loops_mutablet::natural_loopt loop,
                  pathst &loop_paths) = 0;

 protected:
  goto_programt &program;
  goto_functionst &goto_functions;
  const namespacet &ns;
};

#endif
