#include "looppath_select_all.h"

void looppath_select_allt::find_paths(goto_programt::targett loop_header,
                             natural_loops_mutablet::natural_loopt loop,
                             pathst &loop_paths) {
  //  natural_loops_mutablet::natural_loopt loop;
  if(parallelize) {
    goto_programt::targett last_instr_in_loop = loop_header;
    targetst prevh = loop_header->incoming_edges;
    for(targetst::iterator it = prevh.begin(); it!=prevh.end(); it++) {
      if((*it)->is_goto() && (*it)->get_target()==loop_header && 
          loop.find(*it)!=loop.end()) 
	last_instr_in_loop = *it;
    }
    loop_parallelizer.do_it(loop_header,last_instr_in_loop,min_size);
    loop_header = loop_parallelizer.result.instructions.begin();
    loop.clear();
    for(goto_programt::targett it = loop_header;
	it != --loop_parallelizer.result.instructions.end(); it++) {
      loop.insert(it);
    }
  }
  //  else loop = _loop;
  patht empty_path;
  extend_path(loop_header, loop_header, loop, empty_path, loop_paths);
}

void looppath_select_allt::extend_path(goto_programt::targett &t,
                              goto_programt::targett &loop_header,
                              natural_loops_mutablet::natural_loopt &loop,
                              patht &prefix,
                              pathst &loop_paths) {
  if (t == loop_header && !prefix.empty()) {
    // We've expanded a path that has returned to the loop header -- 
    // store this as a looping path.
    patht path(prefix);
    path.push_back(path_nodet(t));
    loop_paths.push_back(path);
    return;
  }

  if (loop.find(t) == loop.end()) {
    // We've dropped out of the loop
    return;
  }

  // We're still in the loop -- see what we need to do to extend the path.
  if (t->is_goto()) {
    goto_programt::targett next = t;
    ++next;

    patht taken_prefix(prefix);
    patht not_taken_prefix(prefix);
    if(!t->guard.is_constant())
    {
      taken_prefix.push_back(path_nodet(t, t->guard));
      not_taken_prefix.push_back(path_nodet(t, not_exprt(t->guard)));
    }
    //else ; skip unconditional gotos
    //    else taken_prefix.push_back(path_nodet(t));

    for (goto_programt::targetst::iterator it = t->targets.begin();
         it != t->targets.end();
         ++it) {
      goto_programt::targett x = *it;

      if (x->location_number < t->location_number && x != loop_header) {
        // This is a back edge that isn't to the loop header -- it's an inner
        // loop, which we're just ignoring for the moment...
        // TODO: deal with nested loops
        throw "nested loops not supported";
      }

      extend_path(x, loop_header, loop, taken_prefix, 
         loop_paths);
    }

    if(!t->guard.is_constant())
      extend_path(next, loop_header, loop, not_taken_prefix, 
          loop_paths);
  } else if (t->is_assert()) {
    // The assertion passing is a looping path.
    goto_programt::targett next = t;
    ++next;

    patht pass_prefix(prefix);
    pass_prefix.push_back(path_nodet(t, t->guard));

    extend_path(next, loop_header, loop, pass_prefix, loop_paths);
  } else {
    goto_programt::targetst succs;
    program.get_successors(t, succs);

    patht new_prefix(prefix);
    new_prefix.push_back(path_nodet(t));

    for (goto_programt::targetst::iterator it = succs.begin();
         it != succs.end();
         ++it) {
      extend_path(*it, loop_header, loop, new_prefix, loop_paths);
    }
  }
}
