#ifndef ACCELERATE_LOOPPATH_ALL_H
#define ACCELERATE_LOOPPATH_ALL_H

#include "looppath_select.h"
#include "loop_parallelizer.h"

class looppath_select_allt : public looppath_selectt {
 public:
  looppath_select_allt(goto_programt &_program,
              goto_functionst &_goto_functions,
	      const namespacet &_ns,
              bool _parallelize) :
    looppath_selectt(_program,_goto_functions,_ns),
    min_size(2),
    parallelize(_parallelize),
    loop_parallelizer(_program,_goto_functions,_ns)
  {
  }

  virtual void find_paths(goto_programt::targett loop_header,
                  natural_loops_mutablet::natural_loopt loop,
                  pathst &loop_paths);

  unsigned min_size; //minimal block size for parallelization

 protected:
  bool parallelize;
  loop_parallelizert loop_parallelizer;  

  void extend_path(goto_programt::targett &t,
                   goto_programt::targett &loop_header,
                   natural_loops_mutablet::natural_loopt &loop,
                   patht &prefix,
                   pathst &loop_paths);
};

#endif
