#ifndef ACCELERATE_LOOPPATH_FILTER_H
#define ACCELERATE_LOOPPATH_FILTER_H

#include "looppath_select.h"
#include "util.h"
#include "loop_parallelizer.h"

class looppath_select_filtert : public looppath_selectt {
 public:
  looppath_select_filtert(goto_programt &_program,
              goto_functionst &_goto_functions,
	      const namespacet &_ns,
              bool _parallelize) :
    looppath_selectt(_program,_goto_functions,_ns),
    min_size(2),
    parallelize(_parallelize),
    loop_parallelizer(_program,_goto_functions,_ns)
  {
  }

  virtual void find_paths(goto_programt::targett loop_header,
                  natural_loops_mutablet::natural_loopt loop,
                  pathst &loop_paths);

  unsigned min_size; //minimal block size for parallelization

 protected:
  bool parallelize;
  loop_parallelizert loop_parallelizer;  

  bool expr_contains_int_arith_rec(const exprt& expr);
  bool filter_int_arith(goto_programt::targett &t);

  void find_accelerable_targets(goto_programt &program,targetst &targets);

  void extend_path_forward(goto_programt::targett &t,
                   goto_programt::targett &loop_header,
                   natural_loops_mutablet::natural_loopt &loop,
                   patht &prefix,
                   pathst &loop_paths,
                   targetst &targets);
  void extend_path_backward(goto_programt::targett &t,
                   goto_programt::targett &loop_header,
                   natural_loops_mutablet::natural_loopt &loop,
                   patht &suffix,
		   pathst &paths,
                   targetst &targets);
};

#endif
