/*******************************************************************\

Module: Function Entry Instrumentation

Author: Daniel Kroening, kroening@kroening.com

\*******************************************************************/

#include <util/cprover_prefix.h>
#include <util/std_code.h>
#include <util/std_expr.h>
#include <util/i2string.h>
#include <util/simplify_expr.h>
#include <set>
#include <iostream>
#include <string>

#include "functiontest.h"

/*******************************************************************\

Function: functiontest

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

void functiontest(
  symbol_tablet &symbol_table,
  goto_functionst &goto_functions)
{
  namespacet ns(symbol_table);
  unsigned assertion_counter = 0;
  Forall_goto_functions(f_it, goto_functions)
  {
    // don't instrument our internal functions
    if(f_it->first==ID_main) continue;
    if(has_prefix(id2string(f_it->first), CPROVER_PREFIX))
      continue;
    
    // patch in a call to `id' at the branch points
    goto_programt &body=f_it->second.body;
    goto_programt::targett i_it = body.instructions.begin();
    goto_programt::targett t1=body.insert_before(i_it);
    t1->make_assertion(true_exprt()); //put "true" assertion as marker
    t1->location.set_comment(
      (TESTGOAL_PREFIX "::function")+i2string(assertion_counter++));
  }
}
